\section{Networking}
\person{Daniel Kahn Gillmor}

Debconf wouldn't function well without an effective network for the
participants to share.  We made it happen.

\subsection{Uplink}

The conference had a fiber connection (100Mbps symmetric) to
\href{http://yota.com.ni}{Yota de Nicaragua}, and Yota provided us a
set of 5 public IPv4 addresses and connectivity from there to the rest
of the Internet.  This uplink was maintained for the full two weeks
(DebCamp and DebConf).  We also had tunneled IPv6 addresses via a free
tunnel to \href{http://tunnelbroker.net}{Hurricane Electric}'s Miami
PoP.

The Yota uplink came into a server room provided by the University
Centroamerica (UCA), and connected to a gigabit switch there, which
connected via fiber links to the various rooms we used on the campus.
UCA generously provided us with media converters so that each
connection effectively terminated in gigabit copper ethernet, which
matched our in-room equipment.

We also placed a single wireless access point directly in the server
room, since that was close enough to the main hacklab to connect in
the event that a media converter or fiber link failed.

\subsection{Hacklabs}

The main hacklab, Xabier Gorostiaga, hosted several dozen people
consistently over the course of the conference, up to about 80, with
at least one active, network-connected machine per person.  Wireless
on its own seemed likely to be congested.

We placed two TP-Link devices at the media converter where the
connection to the server room came in, and connected them to two
additional Buffalo access points on the far side of the room.

Using a handful of 10/100 copper ethernet switches, we ran cabling
to most of the tables, so that wired connectivity was
available to those who wanted it.  This reduced some of the potential
wireless congestion.

The second hacklab, Amando Lopez, was significantly smaller, and
hosted at most 20 people during the course of the conference,
providing ranked rows of seats.  We provided only wireless
connectivity in Amando Lopez, using a TP-Link and a pair of Buffalo
APs.

\subsection{Talk Rooms}

Our primary priority for providing network links in the talk rooms was
for the video team and for the talk presenter.  The secondary priority
was to provide wireless access to the attendees.  We had one fiber
connection between each talk room and the server room, which
terminated in the talk room with a TP-Link device on which we had
disabled the wireless device (the ``room gateway'').  Video team
traffic was entirely over gigabit wired ethernet.

We used VLAN tagging on each room gateway to split traffic and
networks between these two groups, so that traffic could be
prioritized both at the gateway and at the switch in the server room,
and attendee network chatter would be isolated from the more
timing-critical video streams.

In addition to the room gateway, the larger talk room (Aula Magna) had
another TP-Link device, two normal Buffalo access points, and a
Buffalo WZR-HP-AG300H (also in access point mode).

The smaller talk room (Roberto Teran) had two Buffalo APs in addition
to the room gateway.

\subsection{Wireless Access Points}

We used a mixture of 5 TP-Link WR-1043ND, 8 Buffalo WHR-G54 and one
Buffalo WZR-HP-AG300H wireless access points (WAPs), as mentioned
above.

All WAPs were running OpenWRT trunk firmware because of some bugs
affecting the ar71xx boards in the latest release at that time
(10.03.1). The TP-Link and Buffalo WZR-HP-AG300H are based on the
Atheros (ar71xx) platform, which is well supported in modern kernels.
But the Buffalo WHR-G54 devices are based on a Broadcom chipset and
had to be run with a legacy 2.4 kernel (brcm-2.4) because of stability
issues with the kernel 2.6 based firmware builds.

\subsection{Local Servers and Network Configuration}

We ran one main local server, ``homer'', which was used as a router, a
DHCP and DNS server for the local networks, and as a local mirror of
the debian repositories.

We considered a couple possible variants of how attendee network
traffic could be managed.  Under one model, we could have an isolated
layer 2 domain in each room; under another model, we could provide
roaming wireless connectivity, so that a person moving a device
between rooms would retain the same connectivity.

The roaming campus model meant more layer 2 chatter across rooms, but
the isolated networks model meant more interruptions for individual
users.  We opted for the roaming campus model, and it seemed to work
fine (the video team's separate subnet's traffic had priority over the
attendee chatter).

While our uplink to Yota was successfully tested at 100Mbps, our
connectivity to the rest of the 'net was often significantly less than
100Mbps.  It looked like there were regular bottlenecks between Yota
and the next hops.  However, the local mirror relieved a significant
amount of the network traffic, and the conference stayed online most
of the time, barring a few brief power- and thunderstorm-related
outages.


